
export interface YahooFinanceQuoteResponse {
    quoteResponse: YahooFinanceResult<YahooFinanceQuote[]>;
}

export interface YahooFinanceResult<T> {
    error: string | null;
    result: T
}

export interface YahooFinanceQuote {
    shortName: string;
    symbol: string;
    regularMarketPrice: number;
    regularMarketChange: number;
    regularMarketChangePercent: number;
    regularMarketPreviousClose: number;
    regularMarketOpen: number;
    fiftyTwoWeekRange: string
}


export interface YahooFinanceOptionResponse {
    optionChain: YahooFinanceResult<YahooFinanceOptionResult[]>;
}

export interface YahooFinanceOptionResult {
    expirationDates: number[];
    options: YahooFinanceOptions[];
    quote: YahooFinanceQuote;
}

export interface YahooFinanceOptions {
    calls: YahooFinanceOption[];
    puts: YahooFinanceOption[];
}

export interface YahooFinanceOption {
    contractSymbol: string;
    lastTradeDate: number;
    strike: number;
    lastPrice: number;
}


//TODO: Clear this mock data;
export const quoteMockData = {
    "quoteResponse": {
        "error": null,
        "result": [
            {
                "regularMarketChange": 4.5,
                "regularMarketChangePercent": 3.9886546,
                "regularMarketOpen": 117.26,
                "regularMarketPreviousClose": 112.82,
                "regularMarketPrice": 117.32,
                "shortName": "Apple Inc.",
                "symbol": "AAPL",
                "fiftyTwoWeekRange": "53.1525 - 137.98",
            },
            {
                "ask": 211.63,
                "askSize": 9,
                "averageDailyVolume10Day": 43250000,
                "averageDailyVolume3Month": 35562815,
                "bid": 211.25,
                "bidSize": 9,
                "bookValue": 15.626,
                "currency": "USD",
                "displayName": "Microsoft",
                "dividendDate": 1599696000,
                "earningsTimestamp": 1595434164,
                "earningsTimestampEnd": 1603742400,
                "earningsTimestampStart": 1603310400,
                "epsCurrentYear": 6.46,
                "epsForward": 7.34,
                "epsTrailingTwelveMonths": 5.76,
                "esgPopulated": false,
                "exchange": "NMS",
                "exchangeDataDelayedBy": 0,
                "exchangeTimezoneName": "America/New_York",
                "exchangeTimezoneShortName": "EDT",
                "fiftyDayAverage": 212.50658,
                "fiftyDayAverageChange": -1.2165833,
                "fiftyDayAverageChangePercent": -0.0057249204,
                "fiftyTwoWeekHigh": 232.86,
                "fiftyTwoWeekHighChange": -21.570007,
                "fiftyTwoWeekHighChangePercent": -0.092630796,
                "fiftyTwoWeekLow": 132.52,
                "fiftyTwoWeekLowChange": 78.76999,
                "fiftyTwoWeekLowChangePercent": 0.59440076,
                "fiftyTwoWeekRange": "132.52 - 232.86",
                "financialCurrency": "USD",
                "firstTradeDateMilliseconds": 511108200000,
                "forwardPE": 28.786102,
                "fullExchangeName": "NasdaqGS",
                "gmtOffSetMilliseconds": -14400000,
                "language": "en-US",
                "longName": "Microsoft Corporation",
                "market": "us_market",
                "marketCap": 1598968692736,
                "marketState": "POST",
                "messageBoardId": "finmb_21835",
                "postMarketChange": -61.5672,
                "postMarketChangePercent": -29.13872,
                "postMarketPrice": 149.7228,
                "postMarketTime": 1599686588,
                "priceEpsCurrentYear": 32.707428,
                "priceHint": 2,
                "priceToBook": 13.521694,
                "quoteSourceName": "Nasdaq Real Time Price",
                "quoteType": "EQUITY",
                "region": "US",
                "regularMarketChange": 8.62999,
                "regularMarketChangePercent": 4.2583585,
                "regularMarketDayHigh": 214.8399,
                "regularMarketDayLow": 206.7,
                "regularMarketDayRange": "206.7 - 214.8399",
                "regularMarketOpen": 207.6,
                "regularMarketPreviousClose": 202.66,
                "regularMarketPrice": 211.29,
                "regularMarketTime": 1599681601,
                "regularMarketVolume": 43764495,
                "sharesOutstanding": 7567649792,
                "shortName": "Microsoft Corporation",
                "sourceInterval": 15,
                "symbol": "MSFT",
                "tradeable": false,
                "trailingAnnualDividendRate": 2.04,
                "trailingAnnualDividendYield": 0.01006612,
                "trailingPE": 36.68229,
                "triggerable": true,
                "twoHundredDayAverage": 186.7529,
                "twoHundredDayAverageChange": 24.537094,
                "twoHundredDayAverageChangePercent": 0.13138802
            }
        ]
    }
}

export const optionsMockData = {
    "optionChain": {
        "error": null,
        "result": [
            {
                "expirationDates": [
                    1599782400,
                    1600387200,
                    1600992000,
                    1601596800,
                    1602201600,
                    1602806400,
                    1603411200,
                    1605830400,
                    1608249600,
                    1610668800,
                    1616112000,
                    1618531200,
                    1623974400,
                    1631836800,
                    1642723200,
                    1655424000,
                    1663286400
                ],
                "hasMiniOptions": false,
                "options": [
                    {
                        "calls": [
                            {
                                "ask": 65.15,
                                "bid": 64.35,
                                "change": 3.3999977,
                                "contractSize": "REGULAR",
                                "contractSymbol": "AAPL200911C00052500",
                                "currency": "USD",
                                "expiration": 1599782400,
                                "impliedVolatility": 4.597660502929687,
                                "inTheMoney": true,
                                "lastPrice": 64.6,
                                "lastTradeDate": 1599680842,
                                "openInterest": 275,
                                "percentChange": 5.555552,
                                "strike": 52.5,
                                "volume": 143
                            },
                            {
                                "ask": 63.9,
                                "bid": 63.1,
                                "change": 4.199997,
                                "contractSize": "REGULAR",
                                "contractSymbol": "AAPL200911C00053750",
                                "currency": "USD",
                                "expiration": 1599782400,
                                "impliedVolatility": 4.476566904296874,
                                "inTheMoney": true,
                                "lastPrice": 64.2,
                                "lastTradeDate": 1599681239,
                                "openInterest": 261,
                                "percentChange": 6.9999948,
                                "strike": 53.75,
                                "volume": 147
                            }
                        ],
                        "expirationDate": 1599782400,
                        "hasMiniOptions": false,
                        "puts": [
                            {
                                "ask": 0.01,
                                "bid": 0,
                                "change": 0,
                                "contractSize": "REGULAR",
                                "contractSymbol": "AAPL200911P00052500",
                                "currency": "USD",
                                "expiration": 1599782400,
                                "impliedVolatility": 2.8750028125,
                                "inTheMoney": false,
                                "lastPrice": 0.01,
                                "lastTradeDate": 1599589974,
                                "openInterest": 1143,
                                "percentChange": 0,
                                "strike": 52.5,
                                "volume": 53
                            },
                            {
                                "ask": 0.01,
                                "bid": 0,
                                "change": 0,
                                "contractSize": "REGULAR",
                                "contractSymbol": "AAPL200911P00053750",
                                "currency": "USD",
                                "expiration": 1599782400,
                                "impliedVolatility": 2.750003125,
                                "inTheMoney": false,
                                "lastPrice": 0.01,
                                "lastTradeDate": 1599246781,
                                "openInterest": 40,
                                "percentChange": 0,
                                "strike": 53.75,
                                "volume": 28
                            }
                        ]
                    }
                ],
                "quote": {
                    "ask": 117.27,
                    "askSize": 8,
                    "averageDailyVolume10Day": 233119800,
                    "averageDailyVolume3Month": 170533131,
                    "bid": 117.25,
                    "bidSize": 22,
                    "bookValue": 4.218,
                    "currency": "USD",
                    "displayName": "Apple",
                    "dividendDate": 1597276800,
                    "earningsTimestamp": 1596126600,
                    "earningsTimestampEnd": 1604318400,
                    "earningsTimestampStart": 1603882740,
                    "epsCurrentYear": 3.23,
                    "epsForward": 3.86,
                    "epsTrailingTwelveMonths": 3.296,
                    "esgPopulated": false,
                    "exchange": "NMS",
                    "exchangeDataDelayedBy": 0,
                    "exchangeTimezoneName": "America/New_York",
                    "exchangeTimezoneShortName": "EDT",
                    "fiftyDayAverage": 112.823425,
                    "fiftyDayAverageChange": 4.4965744,
                    "fiftyDayAverageChangePercent": 0.03985497,
                    "fiftyTwoWeekHigh": 137.98,
                    "fiftyTwoWeekHighChange": -20.659996,
                    "fiftyTwoWeekHighChangePercent": -0.14973181,
                    "fiftyTwoWeekLow": 53.1525,
                    "fiftyTwoWeekLowChange": 64.167496,
                    "fiftyTwoWeekLowChangePercent": 1.2072338,
                    "fiftyTwoWeekRange": "53.1525 - 137.98",
                    "financialCurrency": "USD",
                    "firstTradeDateMilliseconds": 345479400000,
                    "forwardPE": 30.393784,
                    "fullExchangeName": "NasdaqGS",
                    "gmtOffSetMilliseconds": -14400000,
                    "language": "en-US",
                    "longName": "Apple Inc.",
                    "market": "us_market",
                    "marketCap": 2006465249280,
                    "marketState": "POST",
                    "messageBoardId": "finmb_24937",
                    "postMarketChange": -0.20999908,
                    "postMarketChangePercent": -0.17899683,
                    "postMarketPrice": 117.11,
                    "postMarketTime": 1599686868,
                    "priceEpsCurrentYear": 36.32198,
                    "priceHint": 2,
                    "priceToBook": 27.81413,
                    "quoteSourceName": "Nasdaq Real Time Price",
                    "quoteType": "EQUITY",
                    "region": "US",
                    "regularMarketChange": 4.5,
                    "regularMarketChangePercent": 3.9886546,
                    "regularMarketDayHigh": 119.14,
                    "regularMarketDayLow": 115.26,
                    "regularMarketDayRange": "115.26 - 119.14",
                    "regularMarketOpen": 117.26,
                    "regularMarketPreviousClose": 112.82,
                    "regularMarketPrice": 117.32,
                    "regularMarketTime": 1599681602,
                    "regularMarketVolume": 168404235,
                    "sharesOutstanding": 17102499840,
                    "shortName": "Apple Inc.",
                    "sourceInterval": 15,
                    "symbol": "AAPL",
                    "tradeable": false,
                    "trailingAnnualDividendRate": 0.782,
                    "trailingAnnualDividendYield": 0.0069313953,
                    "trailingPE": 35.59466,
                    "triggerable": true,
                    "twoHundredDayAverage": 85.99835,
                    "twoHundredDayAverageChange": 31.321648,
                    "twoHundredDayAverageChangePercent": 0.3642122
                },
                "strikes": [
                    52.5,
                    53.75,
                    55,
                    56.25,
                    57.5,
                    58.75,
                    60,
                    61.25,
                    62.5,
                    63.75,
                    65,
                    66.25,
                    67.5,
                    68.75,
                    70,
                    71.25,
                    72.5,
                    73.75,
                    75,
                    76.25,
                    77.5,
                    78.75,
                    80,
                    81.25,
                    82.5,
                    83.75,
                    85,
                    86.25,
                    87.5,
                    88.75,
                    90,
                    91.25,
                    92.5,
                    93.75,
                    95,
                    96.25,
                    97.5,
                    98.75,
                    100,
                    101.25,
                    102.5,
                    103.75,
                    105,
                    106.25,
                    107.5,
                    108.75,
                    110,
                    111.25,
                    112.5,
                    113.75,
                    115,
                    116.25,
                    117.5,
                    118.75,
                    120,
                    121.25,
                    122.5,
                    123.75,
                    125,
                    126.25,
                    127.5,
                    128.75,
                    130,
                    131.25,
                    132.5,
                    133.75,
                    135,
                    136.25,
                    137.5,
                    138.75,
                    140,
                    141.25,
                    142.5,
                    143.75,
                    145,
                    146,
                    147.5,
                    149,
                    150,
                    152.5,
                    155,
                    157.5,
                    160,
                    162.5,
                    165,
                    167.5,
                    170,
                    172.5,
                    175,
                    177.5,
                    180,
                    182.5,
                    185,
                    190,
                    210,
                    215,
                    220,
                    225,
                    230,
                    235,
                    240,
                    245,
                    250,
                    255,
                    260,
                    265,
                    270,
                    275,
                    280,
                    285,
                    290,
                    295,
                    300,
                    305,
                    310,
                    315,
                    320,
                    325,
                    330,
                    335,
                    340,
                    345,
                    350,
                    355,
                    360,
                    365,
                    370,
                    375,
                    380,
                    385,
                    390,
                    395,
                    400,
                    405,
                    410,
                    415,
                    420,
                    425,
                    430,
                    435,
                    440,
                    445,
                    450,
                    455,
                    460,
                    465,
                    470,
                    475,
                    480,
                    485,
                    490,
                    495,
                    500,
                    505,
                    510,
                    515,
                    520,
                    525,
                    530,
                    535,
                    540,
                    545,
                    550,
                    555,
                    560,
                    565,
                    570,
                    575,
                    580,
                    590,
                    600,
                    610,
                    620,
                    630,
                    640,
                    650,
                    660,
                    670,
                    680,
                    690,
                    700,
                    710,
                    720,
                    730
                ],
                "underlyingSymbol": "AAPL"
            }
        ]
    }
}
